//
//  FindBreak.cpp
//  ultimategf_osx
//
//  Created by Guillaume Rizk on 22/10/12.
//  Copyright (c) 2012 Guillaume Rizk. All rights reserved.
//

#include "FindBreak.h"
#include "IterativeExtensions.h"

#define VERB
#define MAXINV 1000

//a changer avec lut cest moche
char complNT(char c)
{
	switch(c)
	{
		case 'A':
			return 'T';
		case 'C':
			return 'G';
		case 'T':
			return 'A';
		case 'G':
			return 'C';
		default:
			return 'N';
	}
}



//fonc to mutate kmer : takes kmer, pos (de la fin ,0-based), and nt

// par exemple  kmer  , pos 2 , C
// AAAAAAAAAA
//return
// AAAAAAACAA

void mutate_kmer(kmer_type * kmer, unsigned int pos, unsigned char nt)
{
    //reset at this pos : &    111110011111
    // puis set at this pos |  00000nt00000
    //  printf("mutate pos %i nt %i \n",pos,nt);
    kmer_type reset_mask =  ~((kmer_type)3 << (pos*2));
    kmer_type set_mask =  ((kmer_type)nt) << (pos*2);
    // printf("%llx %llx \n",reset_mask,set_mask);
    *kmer = (*kmer & reset_mask )  | set_mask;
}


void nb_branching(kmer_type graine, int *nb_in, int * nb_out, Bloom * bloom_solid_kmers, Set * debloom)
{
    
    // assert(graine<=revcomp(graine));
    kmer_type new_graine;
    unsigned char result = 0;
    int nt;
    int strand;
    *nb_in=0;
    *nb_out=0;
    
    for(nt=0; nt<4; nt++)
    {
        // forward right extensions
        strand=0;
        new_graine = next_kmer(graine,nt,&strand);
        if(bloom_solid_kmers->contains(new_graine) && !debloom->contains(new_graine)){
            result|=1<<nt;
        }
        
        // reverse right extensions
        strand=1;
        new_graine = next_kmer(graine,nt,&strand);
        if(bloom_solid_kmers->contains(new_graine) && !debloom->contains(new_graine)){
            result|=1<<(nt+4);
            
//            if(graine ==4249520128185247326 )
//            {
//                char kmerbuff[sizeKmer+1];
//                char kmerbuff2[sizeKmer+1];
//                
//                code2seq(graine,kmerbuff);
//                
//                printf("testing  %s \n",kmerbuff);
//                
//                code2seq(new_graine,kmerbuff);
//                code2seq(revcomp(new_graine),kmerbuff2);
//
//                printf("kmer in %s or %s  \n",kmerbuff,kmerbuff2);
//                
//            }
        }
    }
    
    int ii;
    for (ii=0;ii<4;ii++)
        *nb_out += (result>>ii)&1;
    
    for (ii=4;ii<8;ii++)
        *nb_in += (result>>ii)&1;
    
    return ;
}


// for each kmer of the reference, see if it exists in the reads
// 'gaps' corresponds to breakpoints
//for insert sites only 
void findbreakpoints(Bank * Ref, Bloom * bloo1, Set * debloom,Bloom *bloom_ref_repeats, bool with_hetero, int max_tai_rep)
{
    kmer_type kmer_begin, previous_kmer;
    previous_kmer = 0;
    char bin2NT[4]    = {'A','C','T','G'};
    char bin2NTrev[4] = {'T','G','A','C'};
    char binrev[4]    = {2,3,0,1};
    
      
    info_t history[256]; //circu buffer
    
    memset(history,0,sizeof(info_t)*256);
    
    unsigned char current         = sizeKmer + 1;
    unsigned char current_minus_k = 1;
    unsigned char current_minus_k_minus_1 = 0;
    info_t info_pos;
    
    char *buffer, *headerbuffer;
    bool more_seq;
    int readlen, hlen;
    //   Ref->reset_max_readlen(100000000); // 100 M max contig sur ref
    //   more_seq = Ref->get_next_seq(&buffer,&readlen);
    more_seq = Ref->get_next_seq(&buffer,&headerbuffer,&readlen,&hlen);
    //printf("--------more seq    %i   readlen %i-----------\n",more_seq,readlen);
    int recent_hetero =0;
    char kmerbuff[sizeKmer+1];
    char kmerbuff2[sizeKmer+1];
    char kmerbuff3[sizeKmer+1];
    
    
    char tempinv[2*MAXINV];
    char temprev[2*MAXINV];
    
    char seq_debug[256];
    
    Progress * progress_bar = new Progress;
    
    kmer_type kmer, graine, graine_revcomp ;
    kmer_type first_unindexed = 0;
    kmer_type kmer_end = 0;
    site_t begin_inversion = {0,0};
    site_t end_inversion = {0,0};
    
    int j=0;
    uint64_t nb_possible_insertions = 0;
    uint64_t nb_possible_insertions_smaller_gap = 0;
    uint64_t other_event = 0;
    uint64_t nb_hetero_insertions  = 0 ;

    uint64_t nb_coherent = 0;
    uint64_t nb_incoherent = 0 ;
    
    unsigned char branching =0;
    int nb_forward_links = 0;
    int nb_reverse_links = 0;
    
    FILE * break_file = fopen(return_file_name(breakpoints_file_name),"w");
    
    FILE * allbreaks = fopen(return_file_name("breaks"),"w");
    
    FILE * tab_insert_sites = fopen(return_file_name("tabbreaks"),"w");
    
    
    progress_bar->timer_mode=1;
    progress_bar->init(Ref->filesizes,"Scanning reference Genome");
    
    //todo omp on this loop :put var inside, and use binaryconcurrentbank to write output
    while (more_seq)
    {
      //  printf("header \n%s\n",headerbuffer);
        int i;
        //fprintf(allbreaks,"----------------------- seq %i\n",j);
        //i<readlen-sizeKmer+1
        uint64_t tai_not_indexed =0;
        uint64_t tai_previous_break =0;
        uint64_t tai_indexed = 0;
        
        //reset history
        memset(history,0,sizeof(info_t)*256);
        current         = sizeKmer + 1;
        current_minus_k = 1;
        current_minus_k_minus_1 = 0;
        
        //for each kmer in this contig
        
        for (i=0; i<readlen-sizeKmer+1; i++)
        {
            
            
            //remember number of in and out branching of the last 256 seen kmers and store corresponding kmer ?
            
            //then test if two consecutive (non overlapping kmers) have 2 out then 2 in ..  then possible breakpoint...
            
            //todo : small local assembly, to discriminate between insertion and dele of repet ..
            //test recall..
            
            // la detection semble possible avec simplement la 'map' des kmers indexes ?
            // ie un snp donne k kmer non indexes,
            // une deletion en donne bcp : k-1 + taille deletion
            // une insertion en donne :  k-1  (ou moins si pas de bol)
            // une inversion en donne k-1 au debut et k-1 a la fin ?
            kmer = extractKmerFromRead(buffer,i,&graine,&graine_revcomp);
            
            
            /////////////store history in a circulate buffer
            info_pos.kmer = graine;
            nb_forward_links = 0;
            nb_reverse_links = 0;
            
            nb_branching(graine,&nb_reverse_links,&nb_forward_links,bloo1,debloom); // nb_branching de graine plutot ...
            info_pos.nb_in = nb_reverse_links;
            info_pos.nb_out = nb_forward_links;
            
            ///test avec le k-1 mer : il faut reduire de 1 graine, pusi prendre le min avec revcomp  prob qqpart
            kmer_type  tempk = graine & kmerMaskm1 ; // on vire la premiere lettre, celle de gauche, poids fort
            kmer_type rev_tempk = revcomp (tempk, sizeKmer -1);
            tempk = min (tempk,rev_tempk);
            info_pos.is_repeated = bloom_ref_repeats->contains(tempk)  ;
            ////
           // info_pos.is_repeated = bloom_ref_repeats->contains(kmer)  ;
            
            history[current] = info_pos;
            
            ////////////////
            
            
            //for hetero : chek if history[current] has 2 inbranching and history[current-k] has 2 outbranching
            
            //printf("%i %i \n",nb_reverse_links,history[current_minus_k_minus_1].nb_out);
            
            
            kmer_type kmer_mk = history[current_minus_k].kmer;
            kmer_mk = min (kmer_mk,revcomp(kmer_mk));
            
            
//            //////cas simple
//            if(nb_reverse_links==2  && history[current_minus_k].nb_out==2
//               && !(bloom_ref_repeats->contains(kmer)  || bloom_ref_repeats->contains(kmer_mk) )
//               )//
//            {
//                
//                // printf ("current val %i %i \n",current,current_minus_k);
//                
//                //possible hetero insert
//                fprintf(allbreaks,"%lli possible hetero breakpoint seq %i   pos %i   \n",tai_not_indexed,j,i-1); // i is the right side of the insertion
//                
//                code2seq(history[current_minus_k_minus_1].kmer,kmerbuff); //
//                code2seq(graine,kmerbuff2); //graine and not kmer (kmer is the min of graine and its revcomp)
//                fprintf(break_file,">left_contig_%i_%s_pos_%i_HET\n%s\n>right_contig_%i_%s_pos_%i_HET\n%s\n",j,headerbuffer,i-1,kmerbuff,j,headerbuffer,i-1,kmerbuff2);
//                
//                fprintf(tab_insert_sites,"%s %i HET\n",headerbuffer,i-1);
//                
//                nb_hetero_insertions++;
//            }

            
            ///test avec le k-1 mer : du cote droite, il faut virer derniere lettre  prob qqpart
              tempk =  (graine >> 2 ) & kmerMaskm1;
             rev_tempk = revcomp (tempk, sizeKmer -1);
            tempk = min (tempk,rev_tempk);
            bool iskmer_right_repeated = bloom_ref_repeats->contains(tempk)  ;
            
          //  bool iskmer_right_repeated = bloom_ref_repeats->contains(kmer)  ;
            ////
            
            
            //to do make a loop to make it parametrable
            if(
                with_hetero &&
                 (
                  (history[current_minus_k].nb_out==2  &&  ! history[current_minus_k].is_repeated ) ||
                  (history[current_minus_k + 1 ].nb_out==2  &&  ! history[current_minus_k + 1 ].is_repeated ) ||
                  (history[current_minus_k + 2 ].nb_out==2  &&  ! history[current_minus_k + 2 ].is_repeated )
#ifdef HETREP5
                  || (history[current_minus_k + 3 ].nb_out==2  &&  ! history[current_minus_k + 3 ].is_repeated )
                  || (history[current_minus_k + 4 ].nb_out==2  &&  ! history[current_minus_k + 4 ].is_repeated )
                  || (history[current_minus_k + 5 ].nb_out==2  &&  ! history[current_minus_k + 5 ].is_repeated )

#endif
                  )
               
               && 
                (
                 (nb_reverse_links==2   && ! iskmer_right_repeated    ) //    && !bloom_ref_repeats->contains(kmer))
//                || (history[current -1].nb_in==2  &&  ! history[current -1].is_repeated )
//                || (history[current -2].nb_in==2  &&  ! history[current -2].is_repeated )
               
               )
                 && ! recent_hetero
                
                )
            {
                
                
                int true_pos;
                if((history[current_minus_k].nb_out==2  &&  ! history[current_minus_k].is_repeated ))
                    true_pos = 0;
                else if (history[current_minus_k + 1 ].nb_out==2  &&  ! history[current_minus_k + 1 ].is_repeated )
                    true_pos = 1;
                else if (history[current_minus_k + 2 ].nb_out==2  &&  ! history[current_minus_k + 2 ].is_repeated )
                    true_pos = 2;
#ifdef HETREP5
                else if (history[current_minus_k + 3 ].nb_out==2  &&  ! history[current_minus_k + 3 ].is_repeated )
                true_pos = 3;
                else if (history[current_minus_k + 4 ].nb_out==2  &&  ! history[current_minus_k + 4 ].is_repeated )
                true_pos = 4;
                else if (history[current_minus_k + 5 ].nb_out==2  &&  ! history[current_minus_k + 5 ].is_repeated )
                true_pos = 5;
#endif
                
                
                
                
                //il faut decaler kmer de droite si repet, ainsi que pos renvoyee
                
//                printf("nb inbranching %i %i %i \n",history[current_minus_k].nb_in,
//                                                    history[current_minus_k + 1 ].nb_in,
//                                                    history[current_minus_k + 2 ].nb_in);
                
                //possible hetero insert
                //fprintf(allbreaks,"%lli possible hetero breakpoint seq %i   pos %i   \n",tai_not_indexed,j,i-1); // i is the right side of the insertion

                fprintf(allbreaks,"%lli possible hetero breakpoint seq %i   pos %i   out0+1+2||  %i %i %i    in0-1-2|| %i %i %i \n",tai_not_indexed,j,i-1,
                        history[current_minus_k].nb_out,history[current_minus_k+1].nb_out,history[current_minus_k+2].nb_out,
                        nb_reverse_links,history[current -1].nb_in,history[current -2].nb_in
                        ); // i is the right side of the insertion

                
                
               // code2seq(history[current_minus_k_minus_1].kmer,kmerbuff); // current_minus_k_minus_1  //when using current_minus_k, does not start extension..
               
                
                code2seq(history[current_minus_k].kmer,kmerbuff); // now fixed
               // printf("------HET-----\n");
                //new 8 janvier
                if(true_pos==0)
                {
                   code2seq(history[current_minus_k].kmer,kmerbuff);
                }
                else if (true_pos==1)
                {
                    code2seq(history[current_minus_k +1].kmer,kmerbuff);
                }
                else if (true_pos==2)
                {
                    code2seq(history[current_minus_k +2].kmer,kmerbuff);
                }
                //fin 8 janvier
#ifdef HETREP5
                else if (true_pos==3)
                {
                    code2seq(history[current_minus_k +3].kmer,kmerbuff);
                }
                else if (true_pos==4)
                {
                    code2seq(history[current_minus_k +4].kmer,kmerbuff);
                }
                else if (true_pos==5)
                {
                    code2seq(history[current_minus_k +5].kmer,kmerbuff);
                }
#endif
                

                
                //there is a hetmode automatically detected in fill to re-shift correctly
                code2seq(graine,kmerbuff2); //graine and not kmer (kmer is the min of graine and its revcomp)
                if(strcmp(kmerbuff,kmerbuff2)) // do not allow 2 anchors to be equal, reult in strange things happening
                {
                 //   fprintf(break_file,">left_contig_%i_%s_pos_%i_HET\n%s\n>right_contig_%i_%s_pos_%i_HET\n%s\n",j,headerbuffer,i-1,kmerbuff,j,headerbuffer,i-1,kmerbuff2);
                    fprintf(break_file,">left_contig_%i_%s_pos_%i_HET\n%s\n>right_contig_%i_%s_pos_%i_HET\n%.*s\n",j,headerbuffer,i-1+true_pos,kmerbuff,j,headerbuffer,i-1+true_pos,sizeKmer,&buffer[i+true_pos]); // previously buffer[i+1] when shifted

                 //   printf(">left_contig_%i_%s_pos_%i_HET\n%s\n>right_contig_%i_%s_pos_%i_HET\n%.*s\n",j,headerbuffer,i-1+true_pos,kmerbuff,j,headerbuffer,i-1+true_pos,sizeKmer,&buffer[i+true_pos]); // previously buffer[i+1] when shifted


                    
                    //new in 8 janvier + true_pos
                    
                    fprintf(tab_insert_sites,"%s %i HET\n",headerbuffer,i-1);
                
                    nb_hetero_insertions++;
                    recent_hetero = 3;
                }
            }
            
            
            
            
            //   printf("%c  ",buffer[i]);
            if (bloo1->contains(kmer) && !debloom->contains(kmer)) //kmer is indexed
            {
                nb_coherent++;
                tai_indexed++;
                //   printf("kmer indexed ! tai %lli \n",tai_indexed);
                code2seq(kmer_begin,kmerbuff3);
                //il ne faudrait pas sortir zone prec si la tai indexed courante nest que de 1, mais comment faire, on sait pas encore ?
                
                //We are at the beginning of an indexed zone. According to the size of the precedent unindexed zone, we  should know if it is a snp or an insert ..
                if (tai_indexed > 1) // on sort le trou prec au bout du deuxieme bien indexed, pour eviter prob faux positifs
                {
                    if( tai_not_indexed == (sizeKmer-1)) //'clean' size of an insert site
                    {
                        fprintf(allbreaks,"%lli possible breakpoint seq %i   pos %i   %s\n",tai_not_indexed,j,i-1,kmerbuff3); // i is the right side of the insertion
                        
                        code2seq(kmer_begin,kmerbuff);
                        code2seq(kmer_end,kmerbuff2); //graine and not kmer (kmer is the min of graine and its revcomp)
                        fprintf(break_file,">left_contig_%i_%s_pos_%i\n%s\n>right_contig_%i_%s_pos_%i\n%s\n",j,headerbuffer,i-1,kmerbuff,j,headerbuffer,i-1,kmerbuff2);
                        fprintf(tab_insert_sites,"%s %i HOM\n",headerbuffer,i-1);
                        
                        nb_possible_insertions++;
                        
                        
                    }
                    else if ( (sizeKmer - 1 - max_tai_rep)  <= tai_not_indexed && tai_not_indexed <= sizeKmer - 2) // smaller gaps, but also insert site
                    {
                        code2seq(kmer_begin,kmerbuff);
                        code2seq(kmer_end,kmerbuff2); //graine and not kmer (kmer is the min of graine and its revcomp)
                        fprintf(break_file,">left_contig_%i_%s_pos_%i\n%s\n>right_contig_%i_%s_pos_%i\n%.*s\n",j,headerbuffer,i-1 + (sizeKmer - 1 - tai_not_indexed) ,kmerbuff,j,headerbuffer,i-1,sizeKmer,&buffer[i-1+(sizeKmer - 1 - tai_not_indexed)]);//kmerbuff2+ (sizeKmer - 1 - tai_not_indexed) // modif 20 dec  ajout (sizeKmer - 1 - tai_not_indexed) à pos i-1
                        
                        fprintf(tab_insert_sites,"%s %i HOM\n",headerbuffer,i-1);
                        
                        //kmerbuff2  or kmerbuff2+   (sizeKmer - 1 - tai_not_indexed)   ?
                        
                        fprintf(allbreaks,"%lli possible breakpoint seq %i   pos %i    tai %lli  %s\n",tai_not_indexed,j,i-1,tai_not_indexed,kmerbuff3); // i is the right side of the insertion
                        nb_possible_insertions_smaller_gap++ ;
                        
                        
                    }                    
                    else if (tai_not_indexed)
                    {
                        fprintf(allbreaks,"%lli other       seq %i   pos %i tai_not_indexed %lli    %s\n",tai_not_indexed,j,i-1, tai_not_indexed,kmerbuff3 );
                        other_event++;
                    }
                    
                    //     if((tai_not_indexed)
                    //     fprintf(allbreaks,"%lli\n",tai_not_indexed);
                    
                }
                
                if(tai_not_indexed) tai_previous_break = tai_not_indexed;
                if (tai_indexed > 1) tai_not_indexed = 0; // du coup on sort le trou a tai indexed ==2
                if (tai_indexed==1) kmer_end = graine; // kmer_end should be first kmer indexed after a hole
                // on pourrait ne pas faire le reseet si taiindexed ==1, du coup sortir trou que au suivant, pour eviter FP
                
                
            }
            else //kmer is not indexed, measure size of the zone not covered by kmers of the reads
            {
                nb_incoherent++;
                // if(tai_not_indexed == 0 && tai_indexed==1) //si zone indexe prec est ==1, probable FP, merge size, keep old kmer_begin
                if(tai_indexed==1)
                {
                    tai_not_indexed = tai_previous_break + tai_indexed ; //inutile maintenant il me semble, car tai_not_indexed non reset par FP
                }
                // else if(tai_not_indexed==0) // begin of not indexed zone
                else if(tai_indexed > 1) // begin of not indexed zone
                {
                    kmer_begin = previous_kmer ;
                    first_unindexed = graine;
                }
                tai_not_indexed ++;
                tai_indexed =0;
                
            }
            // code2seq(kmer,seq_debug);
            // printf("%c   %s  %lli\n",buffer[i],seq_debug,kmer);
            
            //progress bar
            if (((nb_incoherent + nb_coherent)%10000)==0)
            {
                progress_bar->inc(10000);
            }
            
            previous_kmer = graine;
            current++;
            current_minus_k++;
            current_minus_k_minus_1++;
            
            recent_hetero =  max(0,recent_hetero -1);
        }
        fprintf(allbreaks,"\n");
        // more_seq = Ref->get_next_seq(&buffer,&readlen);
        more_seq = Ref->get_next_seq(&buffer,&headerbuffer,&readlen,&hlen);
       // printf("--------more seq    %i   readlen %i-----------\n",more_seq,readlen);
        j++;
    }
    progress_bar->finish();
    
    fclose(break_file);
    fclose(allbreaks);
    
    fclose(tab_insert_sites);
    printf("found %lli possible insertion sites ( = clean %lli + smaller %lli + hetero %lli) , written to %s\n",nb_possible_insertions+nb_possible_insertions_smaller_gap+nb_hetero_insertions,nb_possible_insertions,nb_possible_insertions_smaller_gap,nb_hetero_insertions,return_file_name(breakpoints_file_name));


    printf("found %lli other events \n",other_event);
    printf("Total Genome length %lli  :  %lli  kmer coherent/ %lli incoherent\n",nb_incoherent+nb_coherent, nb_coherent ,nb_incoherent);
    
    fflush(stdout);
    
}





#define SNP_CONTEXT

void findAllBreakpoints(Bank * Ref, Bloom * bloo1, Set * debloom, Bloom * bloom_ref_repeats)
{
}
/*
// for each kmer of the reference, see if it exists in the reads
// 'gaps' corresponds to breakpoints
//find also snps, indels..
void findAllBreakpoints(Bank * Ref, Bloom * bloo1, Set * debloom, Bloom * bloom_ref_repeats)
{
    kmer_type kmer_begin, previous_kmer;
    previous_kmer = 0;
    char bin2NT[4]    = {'A','C','T','G'};
    char bin2NTrev[4] = {'T','G','A','C'};
    char binrev[4]    = {2,3,0,1};
    
    //for local assembly :
    Traversal *traversal;
    int maxlen=sizeKmer;
    traversal = new SimplePathsTraversal(bloo1,false_positives,terminator);
    traversal->set_maxlen(maxlen);
    traversal->set_max_depth(maxlen);
    traversal->set_max_breadth(20);
    char *right_traversal = (char *) malloc(maxlen*sizeof(char));
    
    
    info_t history[256]; //circu buffer
    
    memset(history,0,sizeof(info_t)*256);
    
    unsigned char current         = sizeKmer + 1;
    unsigned char current_minus_k = 1;
    unsigned char current_minus_k_minus_1 = 0;
    
    info_t info_pos;
    
    char *buffer, *headerbuffer;
    bool more_seq;
    int readlen, hlen;
    //   Ref->reset_max_readlen(100000000); // 100 M max contig sur ref
    //   more_seq = Ref->get_next_seq(&buffer,&readlen);
    more_seq = Ref->get_next_seq(&buffer,&headerbuffer,&readlen,&hlen);
    
    
    char kmerbuff[sizeKmer+1];
    char kmerbuff2[sizeKmer+1];
    char kmerbuff3[sizeKmer+1];
    
    
    char tempinv[2*MAXINV];
    char temprev[2*MAXINV];
    
    char seq_debug[256];
    
    Progress * progress_bar = new Progress;
    
    kmer_type kmer, graine, graine_revcomp ;
    kmer_type first_unindexed = 0;
    kmer_type kmer_end = 0;
    site_t begin_inversion = {0,0};
    site_t end_inversion = {0,0};
    
    int j=0;
    uint64_t nb_possible_insertions = 0;
    uint64_t nb_possible_insertions_smaller_gap = 0;
    uint64_t nb_possible_snp = 0;
    uint64_t other_event = 0;
    uint64_t big_dele = 0;
    uint64_t small_dele = 0;
    
    uint64_t close_snps = 0;
    
    uint64_t nb_coherent = 0;
    uint64_t nb_incoherent = 0 ;
    uint64_t nb_snp_found = 0 ;
    uint64_t nb_hetero_snp_found = 0 ;

    unsigned char branching =0;
    int nb_forward_links = 0;
    int nb_reverse_links = 0;
    
    FILE * break_file = fopen(return_file_name(breakpoints_file_name),"w");
    
    FILE * allbreaks = fopen(return_file_name("breaks"),"w");
    
    FILE * tab_insert_sites = fopen(return_file_name("tabbreaks"),"w");
    
#ifdef SNP_CONTEXT
    FILE * snp_context = fopen(return_file_name("snps_context"),"w");

#endif
    FILE * snp_file = fopen(return_file_name("snps"),"w");
    
    FILE * dele_file = fopen(return_file_name("deletions"),"w");
    
    
    progress_bar->timer_mode=1;
    progress_bar->init(Ref->filesizes,"Scanning reference Genome");
    
    printf("timer mode  %i \n",progress_bar->timer_mode);
    //todo omp on this loop :put var inside, and use binaryconcurrentbank to write output
    while (more_seq)
    {
        //printf("header \n%s\n",headerbuffer);
        int i;
        //fprintf(allbreaks,"----------------------- seq %i\n",j);
        //i<readlen-sizeKmer+1
        uint64_t tai_not_indexed =0;
        uint64_t tai_previous_break =0;
        uint64_t tai_indexed = 0;
        
        //reset history
        memset(history,0,sizeof(info_t)*256);
        current         = sizeKmer + 1;
        current_minus_k = 1;
        current_minus_k_minus_1 = 0;
        
        //for each kmer in this contig
        
        for (i=0; i<readlen-sizeKmer+1; i++)
        {
            
            
            //remember number of in and out branching of the last 256 seen kmers and store corresponding kmer ?
            
            //then test if two consecutive (non overlapping kmers) have 2 out then 2 in ..  then possible breakpoint...
            
            //todo : small local assembly, to discriminate between insertion and dele of repet ..
            //test recall..
            
            // la detection semble possible avec simplement la 'map' des kmers indexes ?
            // ie un snp donne k kmer non indexes,
            // une deletion en donne bcp : k-1 + taille deletion
            // une insertion en donne :  k-1  (ou moins si pas de bol)
            // une inversion en donne k-1 au debut et k-1 a la fin ?
            kmer = extractKmerFromRead(buffer,i,&graine,&graine_revcomp);
            
            
            /////////////store history in a circulate buffer
            info_pos.kmer = graine;
            nb_forward_links = 0;
            nb_reverse_links = 0;
            
            nb_branching(graine,&nb_reverse_links,&nb_forward_links,bloo1,debloom); // nb_branching de graine plutot ...
            info_pos.nb_in = nb_reverse_links;
            info_pos.nb_out = nb_forward_links;
            
            history[current] = info_pos;
            
            ////////////////
            
            
            //for hetero : chek if history[current] has 2 inbranching and history[current-k] has 2 outbranching
            
            //printf("%i %i \n",nb_reverse_links,history[current_minus_k_minus_1].nb_out);
            
            kmer_type kmer_mk = history[current_minus_k].kmer;
            kmer_mk = min (kmer_mk,revcomp(kmer_mk));
            
           // if(nb_reverse_links==2  && history[current_minus_k].nb_out==2)//
             if(nb_reverse_links==2  && history[current_minus_k].nb_out==2
                && !(bloom_ref_repeats->contains(kmer)  || bloom_ref_repeats->contains(kmer_mk) )
                )
            {
                
                // printf ("current val %i %i \n",current,current_minus_k);
                
                //possible hetero insert
                fprintf(allbreaks,"%lli possible hetero breakpoint seq %i   pos %i   \n",tai_not_indexed,j,i-1); // i is the right side of the insertion
                
                code2seq(history[current_minus_k].kmer,kmerbuff);
                code2seq(graine,kmerbuff2); //graine and not kmer (kmer is the min of graine and its revcomp)
                fprintf(break_file,">left_contig_%i_pos_%i_HET\n%s\n>right_contig_%i_pos_%i_HET\n%s\n",j,i-1,kmerbuff,j,i-1,kmerbuff2);
                
                fprintf(tab_insert_sites,"%s %i HET\n",headerbuffer,i-1);
                
                nb_possible_insertions++;
            }
            
            //now search for hetero snps :  history[current] has 2 inbranching and history[current-k-1] has 2 outbranching
         //   if(nb_reverse_links==2  && history[current_minus_k_minus_1].nb_out==2 )
                kmer_type kmer_mk1 = history[current_minus_k_minus_1].kmer;
                kmer_mk1 = min (kmer_mk1,revcomp(kmer_mk1));
            
                if(nb_reverse_links==2  && history[current_minus_k_minus_1].nb_out==2
                 //  && !(bloom_ref_repeats->contains(kmer)  || bloom_ref_repeats->contains(kmer_mk1) )
                   )

                
            {
                //this should be a heterozygous snp
                kmer_type kmer_temp = history[current_minus_k_minus_1].kmer;
                
                int nt;
                //fprintf(snp_file,"%i  %i  %c ",j,i,buffer[i-1]);
                ///fprintf(snp_file,"%s %i  %i  %c ",headerbuffer,j,i,buffer[i-1]);
                
                char nfirst = 0;
                kmer_type new_graine;
                for(nt=0; nt<4; nt++)
                {
                    new_graine = next_kmer(kmer_temp,nt, 0);
                    if(bloo1->contains(new_graine)&& !debloom->contains(new_graine)) //kmer is indexed
                    {
                        
                        if(buffer[i-1]!=bin2NT[nt])
                        {
                            fprintf(snp_file,"%s %i  %i  %c %c\n",headerbuffer,j,i,buffer[i-1],bin2NT[nt]);
#ifdef SNP_CONTEXT
                            fprintf(snp_context,">%s  %i  %c %c HET\n",headerbuffer,i,buffer[i-1],bin2NT[nt]);
                            fprintf(snp_context,"%.*s\n",(2*sizeKmer)-1,&buffer[i-1-sizeKmer+1]);
                            fprintf(snp_context,">%s  %i  %c %c HET\n",headerbuffer,i,buffer[i-1],bin2NT[nt]);
                            fprintf(snp_context,"%.*s%c%.*s\n",
                                    sizeKmer-1,&buffer[i-1-sizeKmer+1],bin2NT[nt],
                                    sizeKmer-1,&buffer[i]);
    
                            
#endif

                            
                        }
                        
                        //fprintf(snp_file,"%c",bin2NT[nt]);
                        /// if (!nfirst) fprintf(snp_file,"%c",bin2NT[nt]);
                        /// else fprintf(snp_file,",%c",bin2NT[nt]);
                        /// nfirst++;
                        
                    }
                }
                // fprintf(snp_file,"\n");
                
                //what to check for hete snp ? anyway everything is indexed
                //we can still mutate and see if it is indexed : ie check kmer pair consitency with the snp
                nb_hetero_snp_found++;
                
            }
            
            
            
            //   printf("%c  ",buffer[i]);
            if (bloo1->contains(kmer) && !debloom->contains(kmer)) //kmer is indexed
            {
                nb_coherent++;
                tai_indexed++;
                //   printf("kmer indexed ! tai %lli \n",tai_indexed);
                code2seq(kmer_begin,kmerbuff3);
                //il ne faudrait pas sortir zone prec si la tai indexed courante nest que de 1, mais comment faire, on sait pas encore ?
                
                //We are at the beginning of an indexed zone. According to the size of the precedent unindexed zone, we  should know if it is a snp or an insert ..
                if (tai_indexed > 1) // on sort le trou prec au bout du deuxieme bien indexed, pour eviter prob faux positifs
                {
                    if( tai_not_indexed == (sizeKmer-1)) //'clean' size of an insert site
                    {
                        fprintf(allbreaks,"%lli possible breakpoint seq %i   pos %i   %s\n",tai_not_indexed,j,i-1,kmerbuff3); // i is the right side of the insertion
                        
                        code2seq(kmer_begin,kmerbuff);
                        code2seq(kmer_end,kmerbuff2); //graine and not kmer (kmer is the min of graine and its revcomp)
                        fprintf(break_file,">left_contig_%i_pos_%i\n%s\n>right_contig_%i_pos_%i\n%s\n",j,i-1,kmerbuff,j,i-1,kmerbuff2);
                        fprintf(tab_insert_sites,"%s %i HOM\n",headerbuffer,i-1);
                        
                        nb_possible_insertions++;
                        
                        
                        
                    }
                    else if(tai_not_indexed == (sizeKmer))  // this should be a snp
                    {
                        //write to the snp file
                        
                        //kmer_begin is the last indexed kmer, test its extension to get the snp
                        int nt;
                        bool check = false;
                        
                        kmer_type new_graine;
                        for(nt=0; nt<4; nt++)
                        {
                            new_graine = next_kmer(kmer_begin,nt, 0);
                            //new_graine = (((kmer_begin) * 4 )  + nt) & kmerMask;
                            if(bloo1->contains(new_graine)&& !debloom->contains(new_graine)) //kmer is indexed
                            {
                                //snp found
                                //ref is the last nt of the first non indexed kmer on the reference genome
                                //contig, pos , ref , snp
                                //                                 fprintf(snp_file,"%i  %i  %c %c  \n",j,i-1,bin2NT[first_unindexed & 3],bin2NT[nt]);
                                //                                 nb_snp_found++;
                                //for higher confidence it would also be possible to test other overlapping kmers
                                check = true;
                                break;
                            }
                        }
                        
                        //verif other kmers :
                        //debug
                        //We are at the second correctly indexed kmer : pos - 2 -k should be just before the hole, yes
                        //so current -k -1 is the first unindexed (snp at pos 0)
                        //current -k is the second unindexed  (snp at pos 1)
                        for(int kk=0;kk<3;kk++)//checks 3 more kmers to verify this snp
                        {
                            kmer_type temp = history[(unsigned char)(current-sizeKmer+kk)].kmer;
                            mutate_kmer(&temp,kk+1,nt);
                            temp = min(temp,revcomp(temp));
                            //  code2seq(temp,kmerbuff3);
                            //  printf("%s\n",kmerbuff3);
                            if( ! bloo1->contains(temp) || debloom->contains(temp)) //kmer is  not indexed
                            {
                                check = false; break;
                            }
                        }
                        if(check)
                        {
                            //fprintf(snp_file,"%i  %i  %c %c  \n",j,i-1,bin2NT[first_unindexed & 3],bin2NT[nt]);
                            fprintf(snp_file,"%s %i  %i  %c %c  \n",headerbuffer,j,i-1,bin2NT[first_unindexed & 3],bin2NT[nt]);

                            
#ifdef SNP_CONTEXT
                            fprintf(snp_context,">%s  %i  %c %c HOM\n",headerbuffer,i-1,bin2NT[first_unindexed & 3],bin2NT[nt]);
                            fprintf(snp_context,"%.*s\n",(2*sizeKmer)-1,&buffer[i-2-sizeKmer+1]);
                            fprintf(snp_context,">%s  %i  %c %c HOM\n",headerbuffer,i-1,bin2NT[first_unindexed & 3],bin2NT[nt]);
                            fprintf(snp_context,"%.*s%c%.*s\n",
                                    sizeKmer-1,&buffer[i-2-sizeKmer+1],bin2NT[nt],
                                    sizeKmer-1,&buffer[i-1]);
                                    
                                    
#endif
                            
                            nb_snp_found++;
                        }
                        //find debug
                        
                        
                        fprintf(allbreaks,"%lli possible SNP        seq %i   pos %i    %s\n",tai_not_indexed,j,i-1,kmerbuff3);
                        nb_possible_snp++;
                    }
                    else if (tai_not_indexed>sizeKmer && tai_not_indexed<2*sizeKmer) //could be two close snps
                        //could also be two close insertions, but not treated for now, and it is low priority
                        //can also be a deletion, need to be distinguished from two close snps
                    {
                        
                        
                        fprintf(allbreaks,"%lli possible two close SNPs or small del   seq %i   pos %i tai_not_indexed %lli    %s\n",tai_not_indexed,j,i-1, tai_not_indexed,kmerbuff3 );
                        //kmer_begin is the last indexed kmer, test its extension to get the first snp
                        int nt;
                        kmer_type new_graine;
                        for(nt=0; nt<4; nt++)
                        {
                            new_graine = next_kmer(kmer_begin,nt, 0);
                            if(bloo1->contains(new_graine)&& !debloom->contains(new_graine)) //kmer is indexed
                            {
                                
                                //contig, pos , ref , snp
                                //                                 fprintf(snp_file,"%i  %lli  %c %c  \n",j,i-1-(tai_not_indexed-sizeKmer),bin2NT[first_unindexed & 3],bin2NT[nt]);
                                //                                 nb_snp_found++;
                                break;
                            }
                        }
                        //second snp : il faut tester extension gauche de kmer_end
                        //ref should be  buffer[i-2]
                        int strand =1;
                        int nt2;
                        for(nt2=0; nt2<4; nt2++)
                        {
                            strand = 1;
                            new_graine = next_kmer(kmer_end,nt2, &strand);
                            if(bloo1->contains(new_graine)&& !debloom->contains(new_graine)) //kmer is indexed
                            {
                               /// nt2 = comp_NT[nt2];
                                //contig, pos , ref , snp
                                //                                 fprintf(snp_file,"%i  %i  %c %c  \n",j,i-1,buffer[i-2],bin2NTrev[nt2]);
                                //                                 nb_snp_found++;
                                break;
                            }
                        }
                        
                        //get kmer beginning at first snp, mutate it with the two snps
                        //if it really is a two-snps site, it should be indexed
                        //otherwise it is something else, maybe a deletion
                        kmer_type temp = history[(unsigned char)(current-2 - (tai_not_indexed-sizeKmer))].kmer; //is kmer with first snp at pos (k-1  = first left char)
                        mutate_kmer(&temp,sizeKmer-1,nt);
                        mutate_kmer(&temp,sizeKmer-1 - (tai_not_indexed - sizeKmer),binrev[nt2]);
                        temp = min(temp,revcomp(temp)); //was lacking

                        if(bloo1->contains(temp)&& !debloom->contains(temp)) //kmer is indexed
                        {
                            fprintf(snp_file,"%s %i  %lli  %c %c  \n",headerbuffer,j,i-1-(tai_not_indexed-sizeKmer),bin2NT[first_unindexed & 3],bin2NT[nt]);
                            //fprintf(snp_file,"%i  %lli  %c %c  \n",j,i-1-(tai_not_indexed-sizeKmer),bin2NT[first_unindexed & 3],bin2NT[nt]);
              
               
#ifdef SNP_CONTEXT
                            fprintf(snp_context,">%s  %i  %c %c HOM CLOSE\n",headerbuffer,i-1-(tai_not_indexed-sizeKmer),bin2NT[first_unindexed & 3],bin2NT[nt]);
                            fprintf(snp_context,"%.*s\n",(2*sizeKmer)-1,&buffer[i-1-(tai_not_indexed-sizeKmer) -1 -sizeKmer+1]);
                            fprintf(snp_context,">%s  %i  %c %c HOM CLOSE\n",headerbuffer,i-1-(tai_not_indexed-sizeKmer),bin2NT[first_unindexed & 3],bin2NT[nt]);
                            fprintf(snp_context,"%.*s%c%.*s\n",
                                    sizeKmer-1,&buffer[i-1-(tai_not_indexed-sizeKmer) -1 -sizeKmer+1],bin2NT[nt],
                                    sizeKmer-1,&buffer[i-1-(tai_not_indexed-sizeKmer)]);
                            
#endif
                            
                            
                            nb_snp_found++;
                            fprintf(snp_file,"%s %i  %i  %c %c  \n",headerbuffer,j,i-1,buffer[i-2],bin2NTrev[nt2]);
                            //fprintf(snp_file,"%i  %i  %c %c  \n",j,i-1,buffer[i-2],bin2NTrev[nt2]);
                            
#ifdef SNP_CONTEXT
                            fprintf(snp_context,">%s  %i  %c %c HOM CLOSE\n",headerbuffer,i-1,buffer[i-2],bin2NTrev[nt2]);
                            fprintf(snp_context,"%.*s\n",(2*sizeKmer)-1,&buffer[i-2-sizeKmer+1]);
                            fprintf(snp_context,">%s  %i  %c %c HOM CLOSE\n",headerbuffer,i-1,buffer[i-2],bin2NTrev[nt2]);
                            fprintf(snp_context,"%.*s%c%.*s\n",
                                    sizeKmer-1,&buffer[i-2-sizeKmer+1],bin2NT[nt], //bin2NTrev[nt2] // replace by this ? todo todo
                                    sizeKmer-1,&buffer[i-1]);
#endif
                            nb_snp_found++;
                            
                            
                        }
                        else //not Two snps, test if deletions
                        {
                            kmer_type kmer_del, graine_del, graine_revcomp_del ;
                            //could be a deletion
                            int len_right = traversal->traverse(kmer_begin,right_traversal,0);
                            kmer_del = extractKmerFromRead(right_traversal,0,&graine_del,&graine_revcomp_del,false);
                            kmer_type mmask = ~ ((1 << (6*2)) -1);
                            
                            bool same =false;
                            int dec=0;
                            for(dec=0;dec<6;dec++)
                            {
                                if(   (((kmer_end << (2*dec)) & mmask) & kmerMask)  == ((graine_del & mmask)& kmerMask))
                                {
                                    same =true;break;
                                }
                                
                            }
                            
                            if(same)
                            {
                                int del_size = tai_not_indexed-(sizeKmer-1)+dec;
                                int pos = i-1-del_size +dec;
                                fprintf(dele_file,"%s %i %i  %.*s \n",headerbuffer,pos,del_size,del_size,&buffer[pos-1]);
                                // i-1-del_size  is pos of first nt of the del, 0-based
                                small_dele++;
                                
                            }
                            else
                            {
                                other_event++;
                            }
                            
                            
                        }
                        
                        
                        //                        int len_right = traversal->traverse(starting_kmer,right_traversal,0);
                        
                        
                        close_snps++;//or deletion
                    }
                    //    else if ( sizeKmer - 9  <= tai_not_indexed && tai_not_indexed <= sizeKmer - 7) // test de pic inconnu
                    
                    else if ( sizeKmer - 6  <= tai_not_indexed && tai_not_indexed <= sizeKmer - 2) // smaller gaps, but also insert site
                    {
                        code2seq(kmer_begin,kmerbuff);
                        code2seq(kmer_end,kmerbuff2); //graine and not kmer (kmer is the min of graine and its revcomp)
                        fprintf(break_file,">left_contig_%i_pos_%i\n%s\n>right_contig_%i_pos_%i\n%s\n",j,i-1,kmerbuff,j,i-1,kmerbuff2+ (sizeKmer - 1 - tai_not_indexed));
                        fprintf(tab_insert_sites,"%s %i HOM\n",headerbuffer,i-1);
                        
                        //kmerbuff2  or kmerbuff2+   (sizeKmer - 1 - tai_not_indexed)   ?
                        
                        fprintf(allbreaks,"%lli possible breakpoint seq %i   pos %i    tai %lli  %s\n",tai_not_indexed,j,i-1,tai_not_indexed,kmerbuff3); // i is the right side of the insertion
                        nb_possible_insertions_smaller_gap++ ;
                        
                        
                    }
                    else if (tai_not_indexed>sizeKmer) //possible big deletions
                    {
                        kmer_type kmer_del, graine_del, graine_revcomp_del ;
                        //could be a deletion
                        int len_right = traversal->traverse(kmer_begin,right_traversal,0);
                        
                        kmer_del = extractKmerFromRead(right_traversal,0,&graine_del,&graine_revcomp_del,false);
                        
                        //compar kmer_del et kmer_end, cut 6 nt at the end, and test 6 shifts
                        //in order to allow for kmr_end to be shifted : it can happen if by chance deletion ends with same nt as the last nt before the deletion
                        kmer_type mmask = ~ ((1 << (6*2)) -1);
                        
                        bool same =false;
                        int dec=0;
                        for(dec=0;dec<6;dec++)
                        {
                            if(   (((kmer_end << (2*dec)) & mmask) & kmerMask)  == ((graine_del & mmask)& kmerMask))
                            {
                                same =true;break;
                            }
                            
                        }
                        
                        if(same)
                        {
                            // printf("dele found \n");
                            // fprintf(dele_file,"%lli other       seq %i   pos %i tai_not_indexed %lli    %s\n",tai_not_indexed,j,i-1, tai_not_indexed,kmerbuff3 );
                            int del_size = tai_not_indexed-(sizeKmer-1)+dec;
                            int pos = i-1-del_size +dec;
                            fprintf(dele_file,"%s %i %i  %.*s \n",headerbuffer,pos,del_size,del_size,&buffer[pos]);
                            
                            big_dele++;
                            
                        }
                        else
                        {
                            other_event++;
                        }
                        fprintf(allbreaks,"%lli big       seq %i   pos %i tai_not_indexed %lli    %s\n",tai_not_indexed,j,i-1, tai_not_indexed,kmerbuff3 );
                        
                        
                    }
                    else if (tai_not_indexed)
                    {
                        fprintf(allbreaks,"%lli other       seq %i   pos %i tai_not_indexed %lli    %s\n",tai_not_indexed,j,i-1, tai_not_indexed,kmerbuff3 );
                        other_event++;
                    }
                    
                    //     if((tai_not_indexed)
                    //     fprintf(allbreaks,"%lli\n",tai_not_indexed);
                    
                }
                
                if(tai_not_indexed) tai_previous_break = tai_not_indexed;
                if (tai_indexed > 1) tai_not_indexed = 0; // du coup on sort le trou a tai indexed ==2
                if (tai_indexed==1) kmer_end = graine; // kmer_end should be first kmer indexed after a hole
                // on pourrait ne pas faire le reseet si taiindexed ==1, du coup sortir trou que au suivant, pour eviter FP
                
                
            }
            else //kmer is not indexed, measure size of the zone not covered by kmers of the reads
            {
                nb_incoherent++;
                // if(tai_not_indexed == 0 && tai_indexed==1) //si zone indexe prec est ==1, probable FP, merge size, keep old kmer_begin
                if(tai_indexed==1)
                {
                    tai_not_indexed = tai_previous_break + tai_indexed ; //inutile maintenant il me semble, car tai_not_indexed non reset par FP
                }
                // else if(tai_not_indexed==0) // begin of not indexed zone
                else if(tai_indexed > 1) // begin of not indexed zone
                {
                    kmer_begin = previous_kmer ;
                    first_unindexed = graine;
                }
                tai_not_indexed ++;
                tai_indexed =0;
                
            }
            // code2seq(kmer,seq_debug);
            // printf("%c   %s  %lli\n",buffer[i],seq_debug,kmer);
            
            //progress bar
            if (((nb_incoherent + nb_coherent)%10000)==0)
            {
                progress_bar->inc(10000);
            }
            
            previous_kmer = graine;
            current++;
            current_minus_k++;
            current_minus_k_minus_1++;
        }
        /// fprintf(allbreaks,"\n");
        // more_seq = Ref->get_next_seq(&buffer,&readlen);
        more_seq = Ref->get_next_seq(&buffer,&headerbuffer,&readlen,&hlen);
        j++;
    }
    progress_bar->finish();
    
    fclose(break_file);
    fclose(allbreaks);
    fclose(snp_file);
    fclose(snp_context);
    fclose(dele_file);
    
    fclose(tab_insert_sites);
    printf("found %lli possible insertion sites (%lli ==k-1) , written to %s\n",nb_possible_insertions+nb_possible_insertions_smaller_gap,nb_possible_insertions,return_file_name(breakpoints_file_name));
    printf("found %lli possible  SNP \n",nb_possible_snp);
    printf("found %lli possible  close SNPs  or small deletion sites \n",close_snps);
    
    printf("identified %lli SNP, written to %s\n",nb_snp_found,return_file_name("snps"));
    printf("identified %lli hetero SNP, written to %s\n",nb_hetero_snp_found,return_file_name("snps"));
    
    printf("found %lli large deletions\n",big_dele);
    printf("found %lli small deletions\n",small_dele);
    
    printf("found %lli other events \n",other_event);
    printf("Total Genome length %lli  :  %lli  kmer coherent/ %lli incoherent\n",nb_incoherent+nb_coherent, nb_coherent ,nb_incoherent);
    
    fflush(stdout);
    
}
*/

void errCorrec(Bank * Ref, Bloom * bloo1, Set * debloom, Bloom * bloom_ref_repeats)
{
}
/*
//adapted to read correction : snp only,  begin/end  gaps cases  correc bank in ram, and output .. read in other files
void errCorrec(Bank * Ref, Bloom * bloo1, Set * debloom, Bloom * bloom_ref_repeats)
{
    kmer_type kmer_begin, previous_kmer;
    previous_kmer = 0;
    char bin2NT[4]    = {'A','C','T','G'};
    char bin2NTrev[4] = {'T','G','A','C'};
    char binrev[4]    = {2,3,0,1};
    
    //for local assembly :
    Traversal *traversal;
    int maxlen=sizeKmer;
    traversal = new SimplePathsTraversal(bloo1,false_positives,terminator);
    traversal->set_maxlen(maxlen);
    traversal->set_max_depth(maxlen);
    traversal->set_max_breadth(20);
    char *right_traversal = (char *) malloc(maxlen*sizeof(char));
    
    
    info_t history[256]; //circu buffer
    
    memset(history,0,sizeof(info_t)*256);
    
    unsigned char current         = sizeKmer + 1;
    unsigned char current_minus_k = 1;
    unsigned char current_minus_k_minus_1 = 0;
    unsigned char first_of_seq    = sizeKmer + 1;

    info_t info_pos;
    
    char *buffer, *headerbuffer;
    bool more_seq;
    bool first_gap = true;
    int readlen, hlen;
    //   Ref->reset_max_readlen(100000000); // 100 M max contig sur ref
    //   more_seq = Ref->get_next_seq(&buffer,&readlen);
    more_seq = Ref->get_next_seq(&buffer,&headerbuffer,&readlen,&hlen);
    
    
    char kmerbuff[sizeKmer+1];
    char kmerbuff2[sizeKmer+1];
    char kmerbuff3[sizeKmer+1];
    
    
    char tempinv[2*MAXINV];
    char temprev[2*MAXINV];
    
    char seq_debug[256];
    
    Progress * progress_bar = new Progress;
    
    kmer_type kmer, graine, graine_revcomp ;
    kmer_type first_unindexed = 0;
    kmer_type kmer_end = 0;
    site_t begin_inversion = {0,0};
    site_t end_inversion = {0,0};
    
    int j=0;
    uint64_t nb_possible_insertions = 0;
    uint64_t nb_possible_insertions_smaller_gap = 0;
    uint64_t nb_possible_snp = 0;
    uint64_t other_event = 0;
    uint64_t big_dele = 0;
    uint64_t small_dele = 0;
    
    uint64_t close_snps = 0;
    
    uint64_t nb_coherent = 0;
    uint64_t nb_incoherent = 0 ;
    uint64_t nb_snp_found = 0 ;
    uint64_t nb_hetero_snp_found = 0 ;
    
    unsigned char branching =0;
    int nb_forward_links = 0;
    int nb_reverse_links = 0;
    
    FILE * break_file = fopen(return_file_name(breakpoints_file_name),"w");
    
    FILE * allbreaks = fopen(return_file_name("breaks"),"w");
    
    FILE * tab_insert_sites = fopen(return_file_name("tabbreaks"),"w");
    
#ifdef SNP_CONTEXT
    FILE * snp_context = fopen(return_file_name("snps_context"),"w");
    
#endif
    FILE * snp_file = fopen(return_file_name("snps"),"w");

    FILE * corr_file = fopen(return_file_name("corrected"),"w");

    FILE * dele_file = fopen(return_file_name("deletions"),"w");
    
    
    progress_bar->timer_mode=1;
    progress_bar->init(Ref->filesizes,"Scanning reference Genome");
    
    printf("timer mode  %i \n",progress_bar->timer_mode);
    //todo omp on this loop :put var inside, and use binaryconcurrentbank to write output
    while (more_seq)
    {
       // printf("header \n%s    : read  %i \n",headerbuffer,j);
        int i, ii;
        //fprintf(allbreaks,"----------------------- seq %i\n",j);
        //i<readlen-sizeKmer+1
        
        //multiple passes per read
        for (ii=0; ii<2; ii++)
        {

        
        uint64_t tai_not_indexed =0;
        uint64_t tai_previous_break =0;
        uint64_t tai_indexed = 0;
        
        //reset history
        memset(history,0,sizeof(info_t)*256);
        current         = sizeKmer + 1;
        current_minus_k = 1;
        current_minus_k_minus_1 = 0;
        
        //for each kmer in this contig
        
        first_gap = true;
        for (i=0; i<readlen-sizeKmer+1; i++)
        {
            
            
            //remember number of in and out branching of the last 256 seen kmers and store corresponding kmer ?
            
            //then test if two consecutive (non overlapping kmers) have 2 out then 2 in ..  then possible breakpoint...
            
            //todo : small local assembly, to discriminate between insertion and dele of repet ..
            //test recall..
            
            // la detection semble possible avec simplement la 'map' des kmers indexes ?
            // ie un snp donne k kmer non indexes,
            // une deletion en donne bcp : k-1 + taille deletion
            // une insertion en donne :  k-1  (ou moins si pas de bol)
            // une inversion en donne k-1 au debut et k-1 a la fin ?
            kmer = extractKmerFromRead(buffer,i,&graine,&graine_revcomp);
            
            
            /////////////store history in a circulate buffer
            info_pos.kmer = graine;   //we store the kmer in forward, not the min
            nb_forward_links = 0;
            nb_reverse_links = 0;
            
            nb_branching(graine,&nb_reverse_links,&nb_forward_links,bloo1,debloom); // nb_branching de graine plutot ...
            info_pos.nb_in = nb_reverse_links;
            info_pos.nb_out = nb_forward_links;
            
            history[current] = info_pos;
            
            ////////////////
            
            
            //for hetero : chek if history[current] has 2 inbranching and history[current-k] has 2 outbranching
            
            //printf("%i %i \n",nb_reverse_links,history[current_minus_k_minus_1].nb_out);
            
            kmer_type kmer_mk = history[current_minus_k].kmer;
            kmer_mk = min (kmer_mk,revcomp(kmer_mk));
                      
            
            //   printf("%c  ",buffer[i]);
            if (bloo1->contains(kmer) && !debloom->contains(kmer)) //kmer is indexed
            {
                nb_coherent++;
                tai_indexed++;
               //    printf("kmer indexed ! tai %lli   %i\n",tai_indexed, i);
                code2seq(kmer_begin,kmerbuff3);
                //il ne faudrait pas sortir zone prec si la tai indexed courante nest que de 1, mais comment faire, on sait pas encore ?
                
                //We are at the beginning of an indexed zone. According to the size of the precedent unindexed zone, we  should know if it is a snp or an insert ..
                if (tai_indexed > 1) // on sort le trou prec au bout du deuxieme bien indexed, pour eviter prob faux positifs
                {

                    if(tai_not_indexed == (sizeKmer))  // this should be a snp
                    {
                        //write to the snp file
                        
                        //kmer_begin is the last indexed kmer, test its extension to get the snp
                        int nt;
                        bool check = false;
                        
                        kmer_type new_graine;
                        for(nt=0; nt<4; nt++)
                        {
                            new_graine = next_kmer(kmer_begin,nt, 0);
                            //new_graine = (((kmer_begin) * 4 )  + nt) & kmerMask;
                            if(bloo1->contains(new_graine)&& !debloom->contains(new_graine)) //kmer is indexed
                            {
                                //snp found
                                //ref is the last nt of the first non indexed kmer on the reference genome
                                //contig, pos , ref , snp
                                //                                 fprintf(snp_file,"%i  %i  %c %c  \n",j,i-1,bin2NT[first_unindexed & 3],bin2NT[nt]);
                                //                                 nb_snp_found++;
                                //for higher confidence it would also be possible to test other overlapping kmers
                                check = true;
                                break;
                            }
                        }
                        
                        //verif other kmers :
                        //debug
                        //We are at the second correctly indexed kmer : pos - 2 -k should be just before the hole, yes
                        //so current -k -1 is the first unindexed (snp at pos 0)
                        //current -k is the second unindexed  (snp at pos 1)
                        
//            //checking code            
//        for(int kk=0;kk<3;kk++)//checks 3 more kmers to verify this snp
//                        {
//                            kmer_type temp = history[(unsigned char)(current-sizeKmer+kk)].kmer;
//                            mutate_kmer(&temp,kk+1,nt);
//                            temp = min(temp,revcomp(temp));
//                            //  code2seq(temp,kmerbuff3);
//                            //  printf("%s\n",kmerbuff3);
//                            if( ! bloo1->contains(temp) || debloom->contains(temp)) //kmer is  not indexed
//                            {
//                                check = false; break;
//                            }
//                        }
                        if(check)
                        {
                            
                            fprintf(snp_file,"%s %i  %i  %c %c  \n",headerbuffer,j,i-1,bin2NT[first_unindexed & 3],bin2NT[nt]);
                             //correc error
                            
                            buffer[i-2]=bin2NT[nt]; //correc in ram
                            
                            nb_snp_found++;
                        }
                        //find debug
                        
                        
                        fprintf(allbreaks,"%lli possible SNP        seq %i   pos %i    %s\n",tai_not_indexed,j,i-1,kmerbuff3);
                        nb_possible_snp++;
                    }
                    else if ((tai_not_indexed < sizeKmer) && first_gap && tai_not_indexed)
                    // a snp at the beginning of the read : tai_not_indexed is smaller even for a single snp
                    //and correct it from the right
                    {
                        
                       // printf("after first gap  %lli   %i\n",tai_not_indexed,i);
                        kmer_type new_graine;
                        
                        // il faut tester extension gauche de kmer_end
                        //ref should be  buffer[i-2]
                        
//                          code2seq(kmer_end,kmerbuff3);
//                          printf("%s\n",kmerbuff3);
                        
                        int strand =1;
                        int nt2;
                        for(nt2=0; nt2<4; nt2++)
                        {
                            strand = 1;
                            new_graine = next_kmer(kmer_end,nt2, &strand);
    
                            if(bloo1->contains(new_graine)&& !debloom->contains(new_graine)) //kmer is indexed
                            {
                                break;
                            }
                        }
                       // printf("after first gap   %c %c  \n",buffer[tai_not_indexed-1],bin2NTrev[nt2]);

//                         //checking code
//                        kmer_type temp = history[first_of_seq].kmer; //first kmer of the read
//                        mutate_kmer(&temp,sizeKmer-tai_not_indexed,nt2); //err is at pos (1 based) tai_not_indexed in teh first kmer
//                        temp = min(temp,revcomp(temp));
//                        
//                        if(bloo1->contains(temp)&& !debloom->contains(temp)) //kmer is indexed, it was a single err
//                            
                        {
                            //correc error
                            
                            buffer[tai_not_indexed-1]=bin2NTrev[nt2]; //correc in ram
                            nb_snp_found++;
                        }
                        
                    }
//                    else if (tai_not_indexed>sizeKmer && tai_not_indexed<2*sizeKmer) //could be two close snps

                    
                    else if (tai_not_indexed)
                    {
                        fprintf(allbreaks,"%lli other       seq %i   pos %i tai_not_indexed %lli    %s\n",tai_not_indexed,j,i-1, tai_not_indexed,kmerbuff3 );
                        other_event++;
                    }
                    
                    //     if((tai_not_indexed)
                    //     fprintf(allbreaks,"%lli\n",tai_not_indexed);
                    first_gap = false;
                }
                
                if(tai_not_indexed) tai_previous_break = tai_not_indexed;
                if (tai_indexed > 1) tai_not_indexed = 0; // du coup on sort le trou a tai indexed ==2
                if (tai_indexed==1) kmer_end = graine; // kmer_end should be first kmer indexed after a hole
                // on pourrait ne pas faire le reseet si taiindexed ==1, du coup sortir trou que au suivant, pour eviter FP
                
                
            }
            else //kmer is not indexed, measure size of the zone not covered by kmers of the reads
            {
               // printf("kmer not indexed ! tai %lli   %i\n",tai_not_indexed,i);
                nb_incoherent++;
                // if(tai_not_indexed == 0 && tai_indexed==1) //si zone indexe prec est ==1, probable FP, merge size, keep old kmer_begin
                if(tai_indexed==1)
                {
                    tai_not_indexed = tai_previous_break + tai_indexed ; //inutile maintenant il me semble, car tai_not_indexed non reset par FP
                }
                // else if(tai_not_indexed==0) // begin of not indexed zone
                else if(tai_indexed > 1) // begin of not indexed zone
                {
                    kmer_begin = previous_kmer ;
                    first_unindexed = graine;
                }
                tai_not_indexed ++;
                tai_indexed =0;
                
                
                
                if(i == (readlen-sizeKmer)) //end of the read, we should treat this  gap here
                    //correc snp with trad method
                {
                    //write to the snp file
                    
                    //We should have history[current - tai_not_indexed] == kmer_begin  //todo verify this
                    //kmer_begin is the last indexed kmer, test its extension to get the snp
                    int nt;
                    bool check = false;
                    
                    kmer_type new_graine;
                    for(nt=0; nt<4; nt++)
                    {
                        new_graine = next_kmer(kmer_begin,nt, 0);
                        if(bloo1->contains(new_graine)&& !debloom->contains(new_graine)) //kmer is indexed
                        {
                            check = true;
                            break;
                        }
                    }
                    
                    //verif other kmers :
//de activate checking pour linstant
//                    //checking code
//                    for(int kk=0;kk<3;kk++)//checks 3 more kmers to verify this snp
//                    {
//                        kmer_type temp = history[(unsigned char)(current-sizeKmer+kk)].kmer;
//                        mutate_kmer(&temp,kk+1,nt);
//                        temp = min(temp,revcomp(temp));
//                        //  code2seq(temp,kmerbuff3);
//                        //  printf("%s\n",kmerbuff3);
//                        if( ! bloo1->contains(temp) || debloom->contains(temp)) //kmer is  not indexed
//                        {
//                            check = false; break;
//                        }
//                    } 
                    if(check)
                    {
                        
                        fprintf(snp_file,"%s %i  %i  %c %c  \n",headerbuffer,j,i-1,bin2NT[first_unindexed & 3],bin2NT[nt]);
                        //correc error
                        
                        buffer[readlen-1 - tai_not_indexed +1]=bin2NT[nt]; //correc in ram //todo verify this

                        
                        nb_snp_found++;
                    }
                    //find debug
                    
                    
                    fprintf(allbreaks,"%lli possible SNP        seq %i   pos %i    %s\n",tai_not_indexed,j,i-1,kmerbuff3);
                    nb_possible_snp++;
                }
                
                
            }
            // code2seq(kmer,seq_debug);
            // printf("%c   %s  %lli\n",buffer[i],seq_debug,kmer);
            
            //progress bar
            if (((nb_incoherent + nb_coherent)%10000)==0)
            {
                progress_bar->inc(10000);
            }
            
            previous_kmer = graine;
            current++;
            current_minus_k++;
            current_minus_k_minus_1++;
        }
            
        } // end multiple passes per read
        //fin read
        fprintf(corr_file,">%s\n%s\n",headerbuffer,buffer);
        
        
        
        /// fprintf(allbreaks,"\n");
        // more_seq = Ref->get_next_seq(&buffer,&readlen);
        more_seq = Ref->get_next_seq(&buffer,&headerbuffer,&readlen,&hlen);
        j++;
    }
    progress_bar->finish();
    
    fclose(break_file);
    fclose(allbreaks);
    fclose(snp_file);
    fclose(snp_context);
    fclose(dele_file);
    
    fclose(tab_insert_sites);
    printf("found %lli possible insertion sites (%lli ==k-1) , written to %s\n",nb_possible_insertions+nb_possible_insertions_smaller_gap,nb_possible_insertions,return_file_name(breakpoints_file_name));
    printf("found %lli possible  SNP \n",nb_possible_snp);
    printf("found %lli possible  close SNPs  or small deletion sites \n",close_snps);
    
    printf("identified %lli SNP, written to %s\n",nb_snp_found,return_file_name("snps"));
    printf("identified %lli hetero SNP, written to %s\n",nb_hetero_snp_found,return_file_name("snps"));
    
    printf("found %lli large deletions\n",big_dele);
    printf("found %lli small deletions\n",small_dele);
    
    printf("found %lli other events \n",other_event);
    printf("Total Genome length %lli  :  %lli  kmer coherent/ %lli incoherent\n",nb_incoherent+nb_coherent, nb_coherent ,nb_incoherent);
    
    fflush(stdout);
    
}

*/


//#ifdef DEB
//code2seq(kmer_begin,kmerbuff);
//code2seq(revcomp(kmer_begin),kmerbuff2);
//printf("%s           %s\n",kmerbuff,kmerbuff2);
//code2seq(kmer_end,kmerbuff);
//code2seq(revcomp(kmer),kmerbuff2);
//printf("%s           %s\n",kmerbuff,kmerbuff2);
//#endif

//                         end_inversion.kmer =  kmer_end;
//                         end_inversion.pos  =  i-2; // I want pos of last nt in the inversion it is i-2  I think
//                         //call proc to detect inversion with previous inset site
//                         begin_inversion.kmer=kmer_begin;
//                         begin_inversion.pos = i-1; // pos of the first re indexed after the hole

//                         /////////inversion detect
//                         end_inversion.kmer =  kmer_end;
//                         end_inversion.pos  =  i-2; // I want pos of last nt in the inversion it is i-2  I think
//                         //call proc to detect inversion with previous inset site
//
//                         int invlen = end_inversion.pos-begin_inversion.pos ;
//                         if(invlen < MAXINV)
//                         {
//                             code2seq(begin_inversion.kmer,kmerbuff3);
//                             strcpy(tempinv,kmerbuff3);
//                             for(int p=0;p<=invlen-1;p++)
//                             {
//                                 temprev[p] = complNT(buffer[begin_inversion.pos+invlen-1-p]);
//                             }
//                             strncat(tempinv,temprev,invlen);
//                             code2seq(end_inversion.kmer,kmerbuff3);
//
//                             strcat(tempinv,kmerbuff3);
//
//                             printf("tempinv\n%s\n",tempinv);
//                             //then check consistency of tempinv
//                         }
//
//                         begin_inversion.kmer=kmer_begin;
//                         begin_inversion.pos = i-1; // pos of the first re indexed after the hole
//                         /////////////end inversion detec
