//
//  FindBreak.h
//  ultimategf_osx
//
//  Created by Guillaume Rizk on 22/10/12.
//  Copyright (c) 2012 Guillaume Rizk. All rights reserved.
//

#ifndef __ultimategf_osx__FindBreak__
#define __ultimategf_osx__FindBreak__


#include "./minia/Bloom.h"
#include "./minia/Kmer.h"
#include "./minia/Set.h"
#include "./minia/Bank.h"

#include "./minia/Utils.h"
#include <iostream>

typedef struct site_t
{
    kmer_type kmer; //8
    int pos;
} site_t;



typedef struct info_t
{
    kmer_type kmer; //8
    int nb_in;
    int nb_out;
    unsigned char is_repeated;
} info_t;

//

void findbreakpoints(Bank * Ref, Bloom * bloo1, Set * debloom, Bloom * bloom_ref_repeats, bool with_hetero, int max_tai_rep = 5);
void findAllBreakpoints(Bank * Ref, Bloom * bloo1, Set * debloom, Bloom * bloom_ref_repeats);
void errCorrec(Bank * Ref, Bloom * bloo1, Set * debloom, Bloom * bloom_ref_repeats);

#endif /* defined(__ultimategf_osx__FindBreak__) */
