#include <string>

#if __clang__
#include <unordered_map>
#else
#include <tr1/unordered_map>
#endif

#include <set>
#include <vector>
#include <fstream>
#include <stdlib.h>

using namespace std;

// path type
typedef vector<int> unlabeled_path;

class GraphAnalysis {

public:
    static const int max_breadth = 20; //changed from 10 to 20

    string prefix;
    FILE *graph_file;

    int nb_nodes, nb_edges;

    string node_identifier(int node);
    int revcomp_node(int node);

#if __clang__
    std::unordered_map<int,string > node_sequences;
    std::unordered_map<int,set<int> > out_edges;
#else
    std::tr1::unordered_map<int,string > node_sequences;
    std::tr1::unordered_map<int,set<int> > out_edges;
#endif
    


    GraphAnalysis(string prefix);

    

    set<unlabeled_path> find_all_paths(set<int> terminal_nodes, bool &success);
    set<unlabeled_path> find_all_paths(int start_node, set<int> terminal_nodes, unlabeled_path current_path, int &nb_calls, bool &success);
    
    static int debug; // 0: no debug, 1: node id debug, 2: ful sequence debug; useful to see the sequences of the traversed paths
    set<string> paths_to_sequences(set<unlabeled_path> paths, set< std::pair<int,int> > terminal_nodes_with_endpos); // is it also used in mapsembler  ?
};
