
#include "IndexPairs.h"

char compNT(char c)
{
	switch(c)
	{
		case 'A':
			return 'T';
		case 'C':
			return 'G';
		case 'T':
			return 'A';
		case 'G':
			return 'C';
		default:
			return 'N';
	}
}

void buildPairedBranchingKmers(AssocPairedSet *pairedBranchingKmers, Bank *Reads1, Bank *Reads2, Bloom *bloo1, BranchingTerminator *terminator, Set * debloom)
{

    int i;
    bool ok_solid;
    char last_nt, seq[100];
    pair_nt_kmer_t val;
    kmer_type kmer2, kmer1, kmer_aux, graine, graine_revcomp;
    char *buffer1, *buffer2;
    bool more_seq1, more_seq2;
    int nb_read=0;
    int readlen1, readlen2;

    /*
    //create the vector of branching kmers for the second read file
    more_seq2 = Reads2->get_next_seq(&buffer2,&readlen2);
    while (more_seq2)
    {
        //printf("\n%s\n", buffer2);
        kmer_aux = extractKmerFromRead(buffer2,0,&graine,&graine_revcomp);
        for (i=1; i<readlen2-sizeKmer+1; i++)
        {
            kmer2 = kmer_aux;
            kmer_aux = extractKmerFromRead(buffer2,i,&graine,&graine_revcomp);
            if ( bloo1->contains(kmer2) && terminator->is_branching(kmer2)){
                //code2seq(kmer2, seq);
                if (!pairedBranchingKmers->containsNotBinary(kmer2)){
                    pairedBranchingKmers->insert(kmer2);
                    //printf(">%s\n", seq);
                }
            }
        }
        more_seq2 = Reads2->get_next_seq(&buffer2,&readlen2);
    }
    */

    Reads2->rewind_all();
    Reads1->rewind_all();
    pairedBranchingKmers->finalize();

    //for every kmer, add the corresponding couple = (solid kmer from the first read file, nucleotide)
    more_seq1 = Reads1->get_next_seq(&buffer1,&readlen1);
    more_seq2 = Reads2->get_next_seq(&buffer2,&readlen2);

    while (more_seq1 && more_seq2)
    {
       if(nb_read%10000 == 0) printf("nb read %i \n",nb_read);

        ok_solid = false;
        //look for a solid kmer, kmer1, in the contig from Reads1
        for (i=0; i<readlen1-sizeKmer+1; i++)
        {
            kmer1 = extractKmerFromRead(buffer1,i,&graine,&graine_revcomp);
            //test whether the kmer is solid
            if ( bloo1->contains(kmer1) )
            {
                ok_solid = true;
                break;
            }
        }
    
        //if there's no solid kmer in the first read... it sucks, is it really possible?
        if (!ok_solid)
        {
            printf("Error: no solid kmer in the first read");
            exit(1);
        }
    
        //for each kmer in the contig from Reads2 file, that is branching and solid, associate kmer1
        //peut etre on devrait aussi verif dans bloom si vria branchant ou dead end 
        kmer_type graine_prev; //GR
        kmer_aux = extractKmerFromRead(buffer2,0,&graine,&graine_revcomp);
        for (i=1; i<readlen2-sizeKmer+1; i++)
        {
            kmer2 = kmer_aux;
            graine_prev = graine;
            kmer_aux = extractKmerFromRead(buffer2,i,&graine,&graine_revcomp);
        
            //when kmer2 is the last kmer of the read, what do we take as next nt? for the moment we stop before it
        
            code2seq(graine, seq);
            last_nt = seq[sizeKmer-1];
        
            //test whether the kmer is branching and solid
          // if ( terminator->is_branching(kmer2) && bloo1->contains(kmer2) )
                if ( terminator->is_branching(kmer_aux) &&  (bloo1->contains(kmer_aux)   && !debloom->contains(kmer_aux))) //GR
            {
               /* code2seq(kmer2, seq);
                printf("(%s", seq);
                code2seq(graine, seq);
                printf(",%s)\n",seq);*/
                
                nt_kmer_t nk;
//                nk.nt = last_nt;
//                nk.prev_kmer = kmer1;
            
                
//                code2seq(graine_prev, seq);
//                printf("(%s", seq);
//                code2seq(kmer_aux, seq);
//                printf(",%s)\n",seq);
                
                //GR
                code2seq(graine_prev, seq);
                last_nt = compNT(seq[0]);
                nk.nt = last_nt;
                nk.prev_kmer = kmer1;
                
               /* printf("\n%s\n", buffer2);
                 code2seq(kmer1, seq);
                 printf("(%s %c)=", seq, last_nt);
                 code2seq(kmer2, seq);
                 printf("%s\n", seq);*/
            
             //   int is_present = pairedBranchingKmers->get(kmer2, &val);
               int is_present = pairedBranchingKmers->get(kmer_aux, &val); //GR
                
                if (!is_present)
                {
                    //not possible
                    printf("Error: the branching kmer is not present in the index");
                    exit(1);
                }
                else
                {
                    if ( val.nk1.nt == 0)
                        copy_nt_kmer(nk, &(val.nk1));
                    else if (val.nk1.nt  != last_nt)
                        copy_nt_kmer(nk, &(val.nk2));
                 //   pairedBranchingKmers->set(kmer2, val);
                    pairedBranchingKmers->set(kmer_aux, val); //GR

                }
            
            }
        }
    
        more_seq1 = Reads1->get_next_seq(&buffer1,&readlen1);
        more_seq2 = Reads2->get_next_seq(&buffer2,&readlen2);
        nb_read++;
    }
}
